## terraform-docs

A utility to generate documentation from Terraform modules in various output formats

### Synopsis

A utility to generate documentation from Terraform modules in various output formats

```
terraform-docs [PATH] [flags]
```

### Options

```
  -c, --config string               config file name (default ".terraform-docs.yml")
      --header-from string          relative path of a file to read header from (default "main.tf")
  -h, --help                        help for terraform-docs
      --hide strings                hide section [header, inputs, outputs, providers, requirements]
      --hide-all                    hide all sections (default false)
      --output-values               inject output values into outputs (default false)
      --output-values-from string   inject output values from file into outputs (default "")
      --show strings                show section [header, inputs, outputs, providers, requirements]
      --show-all                    show all sections (default true)
      --sort                        sort items (default true)
      --sort-by-required            sort items by name and print required ones first (default false)
      --sort-by-type                sort items by type of them (default false)
```

### SEE ALSO

* [terraform-docs asciidoc](/docs/formats/asciidoc.md)	 - Generate AsciiDoc of inputs and outputs
  * [terraform-docs asciidoc document](/docs/formats/asciidoc-document.md)	 - Generate AsciiDoc document of inputs and outputs
  * [terraform-docs asciidoc table](/docs/formats/asciidoc-table.md)	 - Generate AsciiDoc tables of inputs and outputs
* [terraform-docs json](/docs/formats/json.md)	 - Generate JSON of inputs and outputs
* [terraform-docs markdown](/docs/formats/markdown.md)	 - Generate Markdown of inputs and outputs
  * [terraform-docs markdown document](/docs/formats/markdown-document.md)	 - Generate Markdown document of inputs and outputs
  * [terraform-docs markdown table](/docs/formats/markdown-table.md)	 - Generate Markdown tables of inputs and outputs
* [terraform-docs pretty](/docs/formats/pretty.md)	 - Generate colorized pretty of inputs and outputs
* [terraform-docs tfvars](/docs/formats/tfvars.md)	 - Generate terraform.tfvars of inputs
  * [terraform-docs tfvars hcl](/docs/formats/tfvars-hcl.md)	 - Generate HCL format of terraform.tfvars of inputs
  * [terraform-docs tfvars json](/docs/formats/tfvars-json.md)	 - Generate JSON format of terraform.tfvars of inputs
* [terraform-docs toml](/docs/formats/toml.md)	 - Generate TOML of inputs and outputs
* [terraform-docs xml](/docs/formats/xml.md)	 - Generate XML of inputs and outputs
* [terraform-docs yaml](/docs/formats/yaml.md)	 - Generate YAML of inputs and outputs

###### Auto generated by spf13/cobra on 15-Jul-2020
